+function (window) {
    window.PAHybridKit = {
        __callbacks: {},
        debug: 1,
        URL_SCHEME: "pahybridkit",
        scheme: function (scheme) {
            scheme && (this.URL_SCHEME = scheme);
            return this.URL_SCHEME;
        },
        invokeCallback: function (cbID, removeAfterExecute, cbArgs) {
            return this._pickCallback(cbID, removeAfterExecute).apply(null, cbArgs);
        },
        utils: {
            _incrementId: 0,
            isPlainObj: function (obj) {
                return typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
            },
            isFn: function (fn) {
                return typeof fn === "function";
            },
            uniqId: function (prefix) {
                return prefix + this._incrementId++
            },
            noop: function () {
            },
            isStr: function (v) {
                return typeof v == "string";
            }
        },
        _addCallback: function (cb) {
            var cbID = this.utils.uniqId("_cb");
            this.__callbacks[cbID] = cb;
            return cbID;
        },
        _pickCallback: function (cbID, remove) {
            var cb = this.__callbacks[cbID] || this.utils.noop;
            if (remove !== false) {
                delete this.__callbacks[cbID];
            }
            return cb;
        },
        _fnReplace: function (args) {
            var _this = this,
                util = _this.utils,
                fnReplace = arguments.callee,
                testArrOrObj = function (el) {
                    return Array.isArray(el) || util.isPlainObj(el);
                },
                iterator = function (el, idx, arr) {
                    if (util.isFn(el)) {
                        arr[idx] = _this._addCallback(el);

                    } else if (testArrOrObj(el)) {
                        fnReplace.call(_this, el);
                    }
                };

            if (testArrOrObj(args) == false) {
                return args;
            }

            for (var key in args) {
                args.hasOwnProperty(key) && iterator(args[key], key, args);
            }

            return args;
        },
        call: function (pluginName, fnName, args) {
            var iframe = document.createElement("IFRAME");
            iframe.setAttribute("src", [
                this.URL_SCHEME,
                pluginName,
                fnName,
                encodeURIComponent(JSON.stringify(this._fnReplace(args))),
                +new Date
            ].join(":"));
            this.debug && console.log("call native:", iframe.src);
            document.documentElement.appendChild(iframe);
            iframe.parentNode.removeChild(iframe);
            iframe = null;
            return this;
        },
        inject: function (pluginName, methods){
            var PHK = window.PHK || {},
                plugin = {},
                _this = this;

            pluginName.split(".").reduce(function (previousValue, currentValue) {
                return plugin = previousValue[currentValue] = previousValue[currentValue] || {};
            }, PHK);
            methods.forEach(function (methodName) {
                plugin[methodName] = function (){
                    return _this.call(pluginName, methodName, [].slice.call(arguments));
                };
            });
            window.PHK = PHK;
            return this;
        },
        domEvent: {
            _create: function (name, data) {
                var evt = document.createEvent('Event');
                evt.initEvent(name, true, true);
                evt.data = data;
                evt._args = [].slice.call(arguments).slice(1);
                return evt;
            },
            trigger: function (name, data) {
                document.dispatchEvent( this._create.apply(this, arguments) );
            }
        }
    };
}(window);